#ifndef _3DOFS_H_
#define _3DOFS_H_

#define	LENDIAN(x) ( ((uint32)x & 0xff ) << 24 | ((uint32)x & 0xff00 ) << 8 | ((uint32)x & 0xff0000 ) >> 8 | ((uint32)x & 0xff000000 ) >> 24 )
#define BLOCK_SIZE 2048

enum {
	PLAIN_FILE = 0x00000002,
	DISC_LABEL = 0x00000006,
	SUB_DIRECTORY = 0x00000007,
	LAST_ENTRY_CONT = 0x40000000,
	LAST_ENTRY = 0xc0000000,
};

typedef struct _3do_fs_superblock {
	char unknown1[0x28];
	char magic_number[8];	// 'CD-ROM'
	char unknown2[0x34];
	uint32 number_of_backup_entries;
	uint32 root_pos;
} _3do_fs_superblock;

typedef struct _3do_fs_dir_head {
	uint32 cur_page;
	char unknown1[8];
	uint32 dir_size;
	char unknown2[4];
} _3do_fs_dir_head;

typedef struct _3do_fs_entry {
	uint32 attr;
	char unknown2[4];
	char ext[4];
	char unknown3[4];
	uint32 size;
	uint32 bsize;
	char unknown4[8];
	char name[32];
	uint32 num_of_copy_entries;
	uint32 start_block[1];
} _3do_fs_entry;


#endif
