#ifndef _VNLIST_H
#define _VNLIST_H

#include <fs_interface.h>

typedef struct vnlist_item {
	struct vnlist_item *next;
	vnode_id id;
	mode_t mode;
	uint32 size;
	uint32 pdata;
	char name[33];
} vnlist_item;

struct vnlist_item *vl_add_item(struct vnlist_item **first, struct vnlist_item *item);
struct vnlist_item *vl_find_name(struct vnlist_item *first, const char *name);
struct vnlist_item *vl_find_id(struct vnlist_item *first, vnode_id id);
void vl_free(struct vnlist_item *first);

typedef struct dir_item {
	struct dir_item *next;
	struct vnlist_item *first;
	vnode_id id;
} dir_item;

struct dir_item *di_add_dir(struct dir_item **first, vnode_id id);
struct dir_item *di_find_dir(struct dir_item *first, vnode_id id);
void di_free(struct dir_item *first);

struct vnlist_item *vl_find_r(struct dir_item *first, vnode_id id, struct dir_item **dir);


#endif
